/*
 * Copyright 
 *   2005 axYus - www.axyus.com
 *   2005 JP.Tessire - jean-philippe.tessier@axyus.com
 * 
 * This file is part of XEMELIOS.
 * 
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.gouv.finances.cp.xemelios.controls;

import java.io.IOException;

import fr.gouv.finances.cp.utils.Pair;
import fr.gouv.finances.cp.utils.xml.marshal.XmlOutputter;

public class RapportWriter {
	
	private XmlOutputter rapport;
			
	public RapportWriter(XmlOutputter rapportxml){
		rapport = rapportxml;
		startRapport();
	}
	
	private void startRapport(){
		rapport.startTag("ano:DocumentRapport");
		rapport.addAttribute("xmlns:ano",Anomalie.ANOMALY_NS_URI);
		rapport.addAttribute("xmlns:n",Anomalie.ANOMALY_NS_URI);
	}
	
	public void endRapport() throws IOException{
		rapport.endTag("ano:DocumentRapport");
                rapport.close();
	}
	
	public void writeElement(String name,Pair... attrs){
		rapport.startTag("ano:"+name);
		if(attrs.length != 0){
			for(Pair p:attrs){
				rapport.addAttribute("ano:"+p.key,p.libelle);	
			}				
		}
		rapport.endTag("ano:"+name);
	}
	
	public void writeData(String data){
		rapport.addCharacterData(data);
	}
	
	public void openElement(String name,Pair... attrs){
		rapport.startTag("ano:"+name);
		if(attrs.length != 0){
			for(Pair p:attrs){
				rapport.addAttribute(p.libelle,p.key);	
			}				
		}
	}
	
	public void openElement(String name){
		rapport.startTag("ano:"+name);
	}
	
	public void closeElement(String name){
		rapport.endTag("ano:"+name);
	}
}
